//Module : MAILSLOT.H
// Autor: Sasa Popovic
// Version: 1.1
// Date: 24.02.2003
// Email: sasap@uns.ns.ac.yu
// If there are any suggestions or comments,
// you are most welcome to contact me



#ifndef __MAILSLOT_H__
#define __MAILSLOT_H__
                      

class CServerMailslot : public CObject
{
public:
//Constructors / Destructors
  CServerMailslot();
  ~CServerMailslot();

//Operations
  BOOL  Open(LPCTSTR lpszName, DWORD dwMaxMessageSize = 0, DWORD dwReadTimeout = 0,
             LPSECURITY_ATTRIBUTES lpSecurityAttributes = NULL);
  BOOL  Close();
  BOOL  Read(LPVOID lpBuffer, DWORD dwNumberOfBytesToRead, DWORD& dwNumberOfBytesRead);
  BOOL  MessageWaiting();
  DWORD MessageCount();
  DWORD SizeOfWaitingMessage();
  DWORD MaximumMessageSize();
  BOOL  SetReadTimeout(DWORD dwReadTimeout);
  BOOL  GetCreationTime(LPFILETIME lpCreationTime);
  BOOL  GetLastAccessTime(LPFILETIME lpLastAccessTime);
  BOOL  GetLastWriteTime(LPFILETIME lpLastWriteTime);
  BOOL  IsOpen() const;

//if you really must have access to the internal handle then here
//it is. You should only use this as a last resource
  operator HANDLE() { return m_hMailslot; };


//Diagnostics / Debug support
#ifdef _DEBUG
  virtual void AssertValid() const;
  virtual void Dump(CDumpContext& dc) const;
#endif

protected:
  HANDLE m_hMailslot;
};

#endif //__MAILSLOT_H__