// WinChatDlg.cpp : implementation file
// Autor: Sasa Popovic
// Version: 1.1
// Date: 24.02.2003
// Email: sasap@uns.ns.ac.yu
// If there are any suggestions or comments,
// you are most welcome to contact me

#include "stdafx.h"
#include "WinChat.h"
#include "WinChatDlg.h"
#include "HyperLink\\HyperLink.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHyperLink	m_EMailLink;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_STATIC_MY_EMAIL, m_EMailLink);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinChatDlg dialog

CWinChatDlg::CWinChatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinChatDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinChatDlg)
	m_strNewMessage = _T("");
	m_strReceivedMessage = _T("");
	m_strServerToSend = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWinChatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinChatDlg)
	DDX_Text(pDX, IDC_EDIT_NEW_MESSAGE, m_strNewMessage);
	DDX_Text(pDX, IDC_EDIT_RECEIVED_MESSAGES, m_strReceivedMessage);
	DDX_Text(pDX, IDC_EDIT_SERVER_TO_SEND, m_strServerToSend);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinChatDlg, CDialog)
	//{{AFX_MSG_MAP(CWinChatDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_SEND_MESSAGE, OnButtonSendMessage)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_ALL, OnButtonClearAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinChatDlg message handlers

BOOL CWinChatDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	char szHostName[128];

	if( gethostname(szHostName, 128) == 0 ){
		m_strMyCompName = szHostName;		
	}

	WinExec("net stop messenger", SW_HIDE);
	m_nTimerIDMessengerStop = SetTimer(1, 4000, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWinChatDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWinChatDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWinChatDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CWinChatDlg::DoSendStandardMessage(LPCTSTR lpSender, LPCTSTR lpRecipient, LPCTSTR lpMsgText)
{
	int nResult; 
	HANDLE pHandle; 
	DWORD dwBytesSend; 
	CString strMailslotName, strMsgText; 
	strMailslotName = _T("\\\\"); 
	strMailslotName += lpRecipient; 
	strMailslotName += _T("\\mailslot\\messngr"); 
	strMsgText = lpSender; 
	strMsgText += '\0'; 
	strMsgText += lpRecipient; 
	strMsgText += '\0'; 
	strMsgText += lpMsgText; 
	strMsgText += '\0'; 

	pHandle = CreateFile( strMailslotName, GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ); 
	nResult = WriteFile( pHandle, strMsgText, ( DWORD )strMsgText.GetLength(), &dwBytesSend, NULL ); 
	return nResult;
}

void CWinChatDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent == m_nTimerID)	CheckForNewMail();	
	if(nIDEvent == m_nTimerIDMessengerStop) {
		KillTimer(m_nTimerIDMessengerStop);
		if (!m_ServerMailslot.Open(_T("messngr"))){
			CString strMessage;
			strMessage="Mailslot not initialized!";
			strMessage+="\n\nYou can send messages";
			strMessage+="\nbut can't receive any";
			strMessage+="\n\nClose any running message exchange program";
			strMessage+="\nand reset WinChat\nto be able to receive messages";
			MessageBox(strMessage, "Error", MB_ICONERROR);
		  }
		  else{
				m_nTimerID = SetTimer(2, 2000, NULL);
		  }
		
	}

	CDialog::OnTimer(nIDEvent);
}

void CWinChatDlg::CheckForNewMail()
{
  //Read all the messages waiting in 
  //the server mailslot
  while (m_ServerMailslot.MessageWaiting())
  {
    DWORD dwMsgSize = m_ServerMailslot.SizeOfWaitingMessage();
    BYTE* pMsg = new BYTE[dwMsgSize];

    DWORD dwNumberOfBytesRead=0;
    if (m_ServerMailslot.Read(pMsg, dwMsgSize, dwNumberOfBytesRead))
    {
		CString strTemp, strTemp2, strTemp3;
		strTemp = pMsg;
		int nCurrentSize = strTemp.GetLength();
		nCurrentSize++;
		while(pMsg[nCurrentSize]!='\0'){
			strTemp2+=pMsg[nCurrentSize++];
		}
		nCurrentSize++;
		while(pMsg[nCurrentSize]!='\0'){
			strTemp3+=pMsg[nCurrentSize++];
		}
	
		AddNewMessage(strTemp, strTemp2, strTemp3);
		PlaySound(MAKEINTRESOURCE(IDR_WAVE_PERSONAL),NULL,SND_RESOURCE | SND_ASYNC); 

	}
    delete []pMsg;
  }

}

void CWinChatDlg::OnButtonSendMessage() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(!m_strServerToSend.IsEmpty() ){
		if(!DoSendStandardMessage(m_strMyCompName, 
			m_strServerToSend, m_strNewMessage) ){

			MessageBox("Message is not sent","Error");
		}
		else{
			AddNewMessage(m_strMyCompName, m_strServerToSend,
				m_strNewMessage);
		}
	}
	else{
		MessageBox("You can not send message to nobody",
			"Error");
	}
}

void CWinChatDlg::AddNewMessage(CString strServer, CString strToServer, CString strMessage)
{
	CString strTemp, tempAll, strDayOfWeek;
	LPSYSTEMTIME lpSystemTime = new _SYSTEMTIME;
	GetLocalTime(lpSystemTime);
		
	switch(lpSystemTime->wDayOfWeek){
	case 1:
		strDayOfWeek = "Monday";
		break;
	case 2:
		strDayOfWeek = "Tuesday";
		break;
	case 3:
		strDayOfWeek = "Wednesday";
		break;
	case 4:
		strDayOfWeek = "Thursday";
		break;
	case 5:
		strDayOfWeek = "Friday";
		break;
	case 6:
		strDayOfWeek = "Saturday";
		break;
	case 7:
		strDayOfWeek = "Sunday";
		break;
	}
	strTemp.Format("<%s> for <%s>    %s:  %d: %d: %d\r\n%s\r\n", 
		strServer, strToServer, strDayOfWeek,
		lpSystemTime->wHour, lpSystemTime->wMinute, lpSystemTime->wSecond,
		strMessage);
	tempAll = m_strReceivedMessage;
	m_strReceivedMessage =strTemp;
	m_strReceivedMessage+="\r\n";
	m_strReceivedMessage+=tempAll;
	UpdateData(FALSE);

}


void CWinChatDlg::OnButtonClearAll() 
{
	m_strNewMessage = "";
	m_strServerToSend = "";
	UpdateData(FALSE);
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_EMailLink.SetURL(_T("mailto:sasap@uns.ns.ac.yu"));
	m_EMailLink.SetUnderline(CHyperLink::ulAlways);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}